# __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits > Class Template Reference

Inheritance diagram for __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >:

List of all members.

## Detailed Description

### template<typename _CharT, typename _Traits = std::char_traits<_CharT>>
class __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >

Definition at line 51 of file stdio_sync_filebuf.h.

- locale getloc () const
- locale pubimbue (const locale &__loc)
- pos_type pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
- pos_type pubseekpos (pos_type __sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
- __streambuf_type * pubsetbuf (char_type *__s, streamsize __n)
- int pubsync ()
- locale _M_buf_locale
- char_type * _M_in_beg
- char_type * _M_in_cur
- char_type * _M_in_end
- char_type * _M_out_beg
- char_type * _M_out_cur
- char_type * _M_out_end

## Public Types

- typedef _CharT char_type
- typedef traits_type::int_type int_type
- typedef traits_type::off_type off_type
- typedef traits_type::pos_type pos_type
- typedef _Traits traits_type

- typedef basic_streambuf< char_type,
  traits_type > __streambuf_type

## Public Member Functions

- std::__c_file *const file ()
- streamsize in_avail ()
- int_type sbumpc ()
- int_type sgetc ()
- streamsize sgetn (char_type *__s, streamsize __n)
- int_type snextc ()
- int_type sputbackc (char_type __c)
- int_type sputc (char_type __c)
- streamsize sputn (const char_type *__s, streamsize __n)
- stdio_sync_filebuf (std::__c_file *__f)
- void stossc ()
- int_type sungetc ()
- template<> stdio_sync_filebuf< wchar_t
  >::int_type syncgetc ()
- template<> stdio_sync_filebuf< char
  >::int_type syncgetc ()
- template<> stdio_sync_filebuf< wchar_t
  >::int_type syncputc (int_type __c)
- template<> stdio_sync_filebuf< char
  >::int_type syncputc (int_type __c)
- template<> stdio_sync_filebuf< wchar_t
  >::int_type syncungetc (int_type __c)
- template<> stdio_sync_filebuf< char
  >::int_type syncungetc (int_type __c)
- template<> std::streamsize xsgetn (wchar_t *__s, std::streamsize __n)
- template<> std::streamsize xsgetn (char *__s, std::streamsize __n)
- template<> std::streamsize xsputn (const wchar_t *__s, std::streamsize __n)
- template<> std::streamsize xsputn (const char *__s, std::streamsize __n)

## Protected Member Functions

- void gbump (int __n)
- virtual void imbue (const locale &)
- virtual int_type overflow (int_type __c=traits_type::eof())
- virtual int_type pbackfail (int_type __c=traits_type::eof())
- void pbump (int __n)
- virtual pos_type seekoff (off_type, ios_base::seekdir, ios_base::openmode=ios_base::in|ios_base::out)
- virtual std::streampos seekoff (std::streamoff __off, std::ios_base::seekdir __dir, std::ios_base::openmode=std::ios_base::in|std::ios_base::out)
- virtual pos_type seekpos (pos_type, ios_base::openmode=ios_base::in|ios_base::out)
- virtual std::streampos seekpos (std::streampos __pos, std::ios_base::openmode __mode=std::ios_base::in|std::ios_base::out)
- virtual basic_streambuf< char_type,
  _Traits > * setbuf (char_type *, streamsize)
- void setg (char_type *__gbeg, char_type *__gnext, char_type *__gend)
- void setp (char_type *__pbeg, char_type *__pend)
- virtual streamsize showmanyc ()
- virtual int sync ()
- int_type syncgetc ()
- int_type syncputc (int_type __c)
- int_type syncungetc (int_type __c)
- virtual int_type uflow ()
- virtual int_type underflow ()
- virtual std::streamsize xsgetn (char_type *__s, std::streamsize __n)
- virtual std::streamsize xsputn (const char_type *__s, std::streamsize __n)

- char_type * eback () const
- char_type * egptr () const
- char_type * gptr () const

- char_type * epptr () const
- char_type * pbase () const
- char_type * pptr () const

## Friends

- template<typename _CharT2> __gnu_cxx::__enable_if< __is_char<
  _CharT2 >::__value, _CharT2
  * >::__type __copy_aux (istreambuf_iterator< _CharT2 >, istreambuf_iterator< _CharT2 >, _CharT2 *)
- streamsize __copy_streambufs_eof (__streambuf_type *, __streambuf_type *, bool &)
- class basic_ios< char_type, traits_type >
- class basic_istream< char_type, traits_type >
- class basic_ostream< char_type, traits_type >
- template<typename _CharT2> __gnu_cxx::__enable_if< __is_char<
  _CharT2 >::__value, istreambuf_iterator<
  _CharT2 > >::__type find (istreambuf_iterator< _CharT2 >, istreambuf_iterator< _CharT2 >, const _CharT2 &)
- template<typename _CharT2, typename _Traits2, typename _Alloc> basic_istream< _CharT2, _Traits2 > & getline (basic_istream< _CharT2, _Traits2 > &, basic_string< _CharT2, _Traits2, _Alloc > &, _CharT2)
- class istreambuf_iterator< char_type, traits_type >
- template<typename _CharT2, typename _Traits2, typename _Alloc> basic_istream< _CharT2, _Traits2 > & operator>> (basic_istream< _CharT2, _Traits2 > &, basic_string< _CharT2, _Traits2, _Alloc > &)
- template<typename _CharT2, typename _Traits2> basic_istream< _CharT2, _Traits2 > & operator>> (basic_istream< _CharT2, _Traits2 > &, _CharT2 *)
- class ostreambuf_iterator< char_type, traits_type >

## Member Typedef Documentation

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef _CharT __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::char_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 55 of file stdio_sync_filebuf.h.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef traits_type::int_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::int_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 57 of file stdio_sync_filebuf.h.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef traits_type::off_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::off_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 59 of file stdio_sync_filebuf.h.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef traits_type::pos_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::pos_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 58 of file stdio_sync_filebuf.h.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

typedef _Traits __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::traits_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 56 of file stdio_sync_filebuf.h.

## Member Function Documentation

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::eback | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 478 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_filebuf< _CharT, _Traits >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::egptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 484 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), std::basic_filebuf< _CharT, _Traits >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

std::__c_file* const __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::file | ( |  | ) | `[inline]`

Returns:
  The underlying FILE*.

This function can be used to access the underlying "C" file pointer. Note that there is no way for the library to track what you do with the file, so be careful.

Definition at line 83 of file stdio_sync_filebuf.h.

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::gbump | ( | int | __n | ) | `[inline, protected, inherited]`

Moving the read position.

Parameters:

  | n | The delta by which to move.

This just advances the read position without returning any data.

Definition at line 494 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::getloc | ( |  | ) | const`[inline, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 241 of file streambuf.

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::gptr | ( |  | ) | const`[inline, protected, inherited]`

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 481 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

template<typename _CharT, typename _Traits>

virtual void std::basic_streambuf< _CharT, _Traits >::imbue | ( | const locale & |  | ) | `[inline, protected, virtual, inherited]`

Changes translations.

Parameters:

  | loc | A new locale.

Translations done during I/O which depend on the current locale are changed by this call. The standard adds, "Between invocations of this function a class derived from streambuf can safely cache results of calls to locale functions and to members of facets so obtained."

Note:
  Base class version does nothing.

Reimplemented in std::basic_filebuf< _CharT, _Traits >.

Definition at line 572 of file streambuf.

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::in_avail | ( |  | ) | `[inline, inherited]`

Looking ahead into the stream.

Returns:
  The number of characters available.

If a read position is available, returns the number of characters available for reading before the buffer must be refilled. Otherwise returns the derived `showmanyc()`.

Definition at line 281 of file streambuf.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual int_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::overflow | ( | int_type | __c = `traits_type::eof()` | ) | `[inline, protected, virtual]`

Consumes data from the buffer; writes to the controlled sequence.

Parameters:

  | c | An additional character to consume.

Returns:
  eof() to indicate failure, something else (usually c, or not_eof())

Informally, this function is called when the output buffer is full (or does not exist, as buffering need not actually be done). If a buffer exists, it is "consumed", with "some effect" on the controlled sequence. (Typically, the buffer is written out to the sequence verbatim.) In either case, the character c is also written out, if c is not `eof()`.

For a formal definiton of this function, see a good text such as Langer & Kreft, or [27.5.2.4.5]/3-7.

A functioning output streambuf can be created by overriding only this function (no buffer area will be used).

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 136 of file stdio_sync_filebuf.h.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual int_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::pbackfail | ( | int_type | __c = `traits_type::eof()` | ) | `[inline, protected, virtual]`

Tries to back up the input sequence.

Parameters:

  | c | The character to be inserted back into the sequence.

Returns:
  eof() on failure, "some other value" on success

Postcondition:
  The constraints of `gptr()`, `eback()`, and `pptr()` are the same as for `underflow()`.

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 111 of file stdio_sync_filebuf.h.

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::pbase | ( |  | ) | const`[inline, protected, inherited]`

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 525 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::pbump | ( | int | __n | ) | `[inline, protected, inherited]`

Moving the write position.

Parameters:

  | n | The delta by which to move.

This just advances the write position without returning any data.

Definition at line 541 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_sync(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), and std::basic_streambuf< _CharT, _Traits >::xsputn().

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::pubimbue | ( | const locale & | __loc | ) | `[inline, inherited]`

Entry point for imbue().

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls the derived imbue(loc).

Definition at line 224 of file streambuf.

template<typename _CharT, typename _Traits>

pos_type std::basic_streambuf< _CharT, _Traits >::pubseekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out` |
| ) |  |  | `[inline, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 258 of file streambuf.

template<typename _CharT, typename _Traits>

pos_type std::basic_streambuf< _CharT, _Traits >::pubseekpos | ( | pos_type | __sp,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out` |
| ) |  |  | `[inline, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 263 of file streambuf.

template<typename _CharT, typename _Traits>

__streambuf_type* std::basic_streambuf< _CharT, _Traits >::pubsetbuf | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inline, inherited]`

Entry points for derived buffer functions.

The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged.

Definition at line 254 of file streambuf.

template<typename _CharT, typename _Traits>

int std::basic_streambuf< _CharT, _Traits >::pubsync | ( |  | ) | `[inline, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 268 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::sync().

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sbumpc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character and increments the read pointer, otherwise calls and returns `uflow()`.

Definition at line 313 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::istreambuf_iterator< _CharT, _Traits >::operator++(), and std::operator>>().

template<typename _CharT, typename _Traits>

virtual pos_type std::basic_streambuf< _CharT, _Traits >::seekoff | ( | off_type | ,
|  | ios_base::seekdir | ,
|  | ios_base::openmode | = `ios_base::in | ios_base::out` |
| ) |  |  | `[inline, protected, virtual, inherited]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented in std::basic_filebuf< _CharT, _Traits >, and std::basic_stringbuf< _CharT, _Traits, _Alloc >.

Definition at line 598 of file streambuf.

template<typename _CharT, typename _Traits>

virtual pos_type std::basic_streambuf< _CharT, _Traits >::seekpos | ( | pos_type | ,
|  | ios_base::openmode | = `ios_base::in | ios_base::out` |
| ) |  |  | `[inline, protected, virtual, inherited]`

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note:
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented in std::basic_filebuf< _CharT, _Traits >, and std::basic_stringbuf< _CharT, _Traits, _Alloc >.

Definition at line 610 of file streambuf.

template<typename _CharT, typename _Traits>

virtual basic_streambuf<char_type,_Traits>* std::basic_streambuf< _CharT, _Traits >::setbuf | ( | char_type * | ,
|  | streamsize |  |
| ) |  |  | `[inline, protected, virtual, inherited]`

Maniuplates the buffer.

Each derived class provides its own appropriate behavior. See the next-to-last paragraph of http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#2 for more on this function.

Note:
  Base class version does nothing, returns `this`.

Reimplemented in std::basic_filebuf< _CharT, _Traits >, and std::basic_stringbuf< _CharT, _Traits, _Alloc >.

Definition at line 587 of file streambuf.

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::setg | ( | char_type * | __gbeg,
|  | char_type * | __gnext,
|  | char_type * | __gend |
| ) |  |  | `[inline, protected, inherited]`

Setting the three read area pointers.

Parameters:

  | gbeg | A pointer.
  | gnext | A pointer.
  | gend | A pointer.

Postcondition:
  gbeg == `eback()`, gnext == `gptr()`, and gend == `egptr()`

Definition at line 505 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_sync().

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::setp | ( | char_type * | __pbeg,
|  | char_type * | __pend |
| ) |  |  | `[inline, protected, inherited]`

Setting the three write area pointers.

Parameters:

  | pbeg | A pointer.
  | pend | A pointer.

Postcondition:
  pbeg == `pbase()`, pbeg == `pptr()`, and pend == `epptr()`

Definition at line 551 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_sync().

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sgetc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

If the input read position is available, returns that character, otherwise calls and returns `underflow()`. Does not move the read position after fetching the character.

Definition at line 335 of file streambuf.

Referenced by std::__copy_streambufs_eof(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), and std::basic_istream< _CharT, _Traits >::sentry::sentry().

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::sgetn | ( | char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inline, inherited]`

Entry point for xsgetn.

Parameters:

  | s | A buffer area.
  | n | A count.

Returns xsgetn(s,n). The effect is to fill s[0] through s[n-1] with characters from the input sequence, if possible.

Definition at line 354 of file streambuf.

template<typename _CharT, typename _Traits>

virtual streamsize std::basic_streambuf< _CharT, _Traits >::showmanyc | ( |  | ) | `[inline, protected, virtual, inherited]`

Investigating the data available.

Returns:
  An estimate of the number of characters available in the input sequence, or -1.

"If it returns a positive value, then successive calls to `underflow()` will not return `traits::eof()` until at least that number of characters have been supplied. If `showmanyc()` returns -1, then calls to `underflow()` or `uflow()` will fail." [27.5.2.4.3]/1

Note:
  Base class version does nothing, returns zero.

  The standard adds that "the intention is not only that the calls [to underflow or uflow] will not return `eof()` but that they will return "immediately".

  The standard adds that "the morphemes of `showmanyc` are "es-how-many-see", not "show-manic".

Reimplemented in std::basic_filebuf< _CharT, _Traits >, and std::basic_stringbuf< _CharT, _Traits, _Alloc >.

Definition at line 645 of file streambuf.

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::snextc | ( |  | ) | `[inline, inherited]`

Getting the next character.

Returns:
  The next character, or eof.

Calls `sbumpc()`, and if that function returns `traits::eof()`, so does this function. Otherwise, `sgetc()`.

Definition at line 295 of file streambuf.

Referenced by std::__copy_streambufs_eof(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), and std::basic_istream< _CharT, _Traits >::sentry::sentry().

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sputbackc | ( | char_type | __c | ) | `[inline, inherited]`

Pushing characters back into the input stream.

Parameters:

  | c | The character to push back.

Returns:
  The previous character, if possible.

Similar to sungetc(), but c is pushed onto the stream instead of "the previous character". If successful, the next character fetched from the input stream will be c.

Definition at line 368 of file streambuf.

Referenced by std::operator>>(), and std::basic_istream< _CharT, _Traits >::putback().

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sputc | ( | char_type | __c | ) | `[inline, inherited]`

Entry point for all single-character output functions.

Parameters:

  | c | A character to output.

Returns:
  c, if possible.

One of two public output functions.

If a write position is available for the output sequence (i.e., the buffer is not full), stores c in that position, increments the position, and returns `traits::to_int_type(c)`. If a write position is not available, returns `overflow(c)`.

Definition at line 420 of file streambuf.

Referenced by std::__copy_streambufs_eof(), std::basic_istream< _CharT, _Traits >::get(), and std::ostreambuf_iterator< _CharT, _Traits >::operator=().

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::sputn | ( | const char_type * | __s,
|  | streamsize | __n |
| ) |  |  | `[inline, inherited]`

Entry point for all single-character output functions.

Parameters:

  | s | A buffer read area.
  | n | A count.

One of two public output functions.

Returns xsputn(s,n). The effect is to write s[0] through s[n-1] to the output sequence, if possible.

Definition at line 446 of file streambuf.

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::stossc | ( |  | ) | `[inline, inherited]`

Tosses a character.

Advances the read pointer, ignoring the character that would have been read.

See http://gcc.gnu.org/ml/libstdc++/2002-05/msg00168.html

Note:
  This function has been deprecated by the standard. You must define `_GLIBCXX_DEPRECATED` to make this visible; see c++config.h.

Definition at line 782 of file streambuf.

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sungetc | ( |  | ) | `[inline, inherited]`

Moving backwards in the input stream.

Returns:
  The previous character, if possible.

If a putback position is available, this function decrements the input pointer and returns that character. Otherwise, calls and returns pbackfail(). The effect is to "unget" the last character "gotten".

Definition at line 393 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::unget().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual int __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::sync | ( |  | ) | `[inline, protected, virtual]`

Synchronizes the buffer arrays with the controlled sequences.

Returns:
  -1 on failure.

Each derived class provides its own appropriate behavior, including the definition of "failure".

Note:
  Base class version does nothing, returns zero.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 155 of file stdio_sync_filebuf.h.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual int_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::uflow | ( |  | ) | `[inline, protected, virtual]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function does the same thing as `underflow()`, and in fact is required to call that function. It also returns the new character, like `underflow()` does. However, this function also moves the read position forward by one.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 103 of file stdio_sync_filebuf.h.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual int_type __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::underflow | ( |  | ) | `[inline, protected, virtual]`

Fetches more data from the controlled sequence.

Returns:
  The first character from the pending sequence.

Informally, this function is called when the input buffer is exhausted (or does not exist, as buffering need not actually be done). If a buffer exists, it is "refilled". In either case, the next available character is returned, or `traits::eof()` to indicate a null pending sequence.

For a formal definiton of the pending sequence, see a good text such as Langer & Kreft, or [27.5.2.4.3]/7-14.

A functioning input streambuf can be created by overriding only this function (no buffer area will be used). For an example, see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#6

Note:
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 96 of file stdio_sync_filebuf.h.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual std::streamsize __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::xsgetn | ( | char_type * | __s,
|  | std::streamsize | __n |
| ) |  |  | `[protected, virtual]`

Multiple character extraction.

Parameters:

  | s | A buffer area.
  | n | Maximum number of characters to assign.

Returns:
  The number of characters assigned.

Fills s[0] through s[n-1] with characters from the input sequence, as if by `sbumpc()`. Stops when either n characters have been copied, or when `traits::eof()` would be copied.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>>

virtual std::streamsize __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >::xsputn | ( | const char_type * | __s,
|  | std::streamsize | __n |
| ) |  |  | `[protected, virtual]`

Multiple character insertion.

Parameters:

  | s | A buffer area.
  | n | Maximum number of characters to write.

Returns:
  The number of characters written.

Writes s[0] through s[n-1] to the output sequence, as if by `sputc()`. Stops when either n characters have been copied, or when `sputc()` would return `traits::eof()`.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

## Member Data Documentation

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::_M_buf_locale `[protected, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 207 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::basic_filebuf().

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_beg `[protected, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 195 of file streambuf.

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_cur `[protected, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 196 of file streambuf.

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_end `[protected, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 197 of file streambuf.

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_beg `[protected, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 198 of file streambuf.

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_cur `[protected, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 199 of file streambuf.

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_end `[protected, inherited]`

Locale access.

Returns:
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 200 of file streambuf.

The documentation for this class was generated from the following file:

- stdio_sync_filebuf.h